""" Functions dealing with line styles """

import wx

LINE_TYPES = {
    'none': wx.TRANSPARENT,
    'solid': wx.SOLID,
    'long dash': wx.LONG_DASH,
    'short dash': wx.SHORT_DASH,
    'dot': wx.DOT,
    'dot dash': wx.DOT_DASH
}

def NameToStyle(name):
    """ Convert a string name to wx line type. """
    if LINE_TYPES.has_key(name.lower()):
        return LINE_TYPES[name.lower()]
    else:
        return wx.SOLID

def StyleToName(style):
    """ Convert a wx line type to string name. """
    for k, v in LINE_TYPES.iteritems():
        if style == v:
            return k
    return "None"
