
import os
import wx
from utils import decimalDate

##########################################################################
class ImportDialog(wx.Dialog):
	def __init__(self, parent=None, title="Import Data"):
		wx.Dialog.__init__(self, parent, -1, title)

		# Main sizer for dialog
		box0 = wx.BoxSizer(wx.VERTICAL)

		sizer = self.mkSource(box0)
		box0.Add(sizer, 0, wx.GROW|wx.ALL, 5)

		sizer = self.mkOptions(box0)
		box0.Add(sizer, 0, wx.GROW|wx.ALL, 5)

		line = wx.StaticLine(self, -1, size=(20, -1), style=wx.LI_HORIZONTAL)
		box0.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

		btnsizer = wx.StdDialogButtonSizer()

		btn = wx.Button(self, wx.ID_CANCEL)
		btnsizer.AddButton(btn)
		btn = wx.Button(self, wx.ID_OK)
		btn.SetDefault()
		self.Bind(wx.EVT_BUTTON, self.ok, btn)

		btnsizer.AddButton(btn)
		btnsizer.Realize()

		box0.Add(btnsizer, 1, wx.ALIGN_RIGHT|wx.ALL, 5)

		self.SetSizer(box0)
		box0.SetSizeHints(self)

	#----------------------------------
	def mkSource(self, box0):

		# First static box sizer
		box = wx.StaticBox(self, -1, "Data Source")
		sizer = wx.StaticBoxSizer(box, wx.VERTICAL)

#		box1 = wx.BoxSizer(wx.HORIZONTAL)
#		sizer.Add(box1, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL)

#		label = wx.StaticText(self, -1, "Data Format")
#		box1.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

		list = [
			"X Y",
			"Year Month Day Hour Minute Second Value",
			"Year Month Day Hour Minute Value",
			"Year Month Day Hour Value",
			"Year Month Day Value",
			"Year Month Value",
		]
#		self.choice = wx.Choice(self, -1, choices=list)
#		box1.Add(self.choice, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

		text = "File are text files in any of these formats:\n"
		text += " X Y\n"
		text += " Year Month Day Hour Minute Second Value\n"
		text += "Year Month Day Hour Minute Value\n"
		text += "Year Month Day Hour Value\n"
		text += "Year Month Day Value\n"
		text += "Year Month Value"
		t = wx.StaticText(self, -1, text)
		sizer.Add(t, 0, wx.ALIGN_CENTRE, wx.ALL, 5)


		# horizontal box
		box2 = wx.BoxSizer(wx.HORIZONTAL)
		sizer.Add(box2, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL)

		label = wx.StaticText(self, -1, "Filename:")
		box2.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
		self.file = wx.TextCtrl(self, -1, "", size=(250, -1))
		box2.Add(self.file, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
		btn = wx.Button(self, 1, "Browse...")
		self.Bind(wx.EVT_BUTTON, self.browse, btn)
		box2.Add(btn, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

		return sizer

	#----------------------------------
	def mkOptions(self, box0):


		# -------------- second static box sizer
		box = wx.StaticBox(self, -1, "Options")
		sizer2 = wx.StaticBoxSizer(box, wx.VERTICAL)

		# a horizontal box
		box1 = wx.BoxSizer(wx.HORIZONTAL)
		sizer2.Add(box1, 0, wx.GROW|wx.ALL, 2)

		label = wx.StaticText(self, -1, "Lines to Skip")
		box1.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
		self.sc = wx.SpinCtrl(self, -1, "")
		self.sc.SetRange(0, 100)
		self.sc.SetValue(0)
		box1.Add(self.sc, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

		# another horizontal box
		box2 = wx.BoxSizer(wx.HORIZONTAL)
		sizer2.Add(box2, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 2)

		self.checkbox = wx.CheckBox(self, -1, "")
		box2.Add(self.checkbox, wx.ALIGN_LEFT)
		label = wx.StaticText(self, -1, "Use Data ")
		box2.Add(label, 0, wx.ALIGN_LEFT)
		list = ["less than", "equal to", "greater than", "less than or equal to", "greater than or equal to", "not equal to", "between", "not between"]
		self.type = wx.Choice(self, -1, choices=list)
		box2.Add(self.type, 0, wx.ALIGN_LEFT)
		self.le2 = wx.TextCtrl(self, -1, "")
		box2.Add(self.le2, 0, wx.ALIGN_LEFT)
		label = wx.StaticText(self, -1, " and ")
		box2.Add(label, 0, wx.ALIGN_LEFT|wx.ALIGN_CENTER_VERTICAL)
		self.le3 = wx.TextCtrl(self, -1, "")
		box2.Add(self.le3, 0, wx.ALIGN_LEFT)

		return sizer2

	#----------------------------------
	def browse(self, event):
		dlg = wx.FileDialog(
		    self, message="Choose a file", defaultDir=os.getcwd(),
		    defaultFile="", style=wx.OPEN | wx.CHANGE_DIR
		    )
		if dlg.ShowModal() == wx.ID_OK:
			paths = dlg.GetPaths()
			for path in paths:
				print path
				self.file.SetValue(path)

		dlg.Destroy()


	#----------------------------------
	def ok(self, event):
#		format = self.choice.GetStringSelection()
		filename = self.file.GetValue()
		if not filename:
			dlg = wx.MessageDialog(self, "Please enter a file name.", 'A Message Box', wx.OK | wx.ICON_ERROR)
			dlg.ShowModal()
			dlg.Destroy()
			return
		if not os.access(filename, os.F_OK):
			dlg = wx.MessageDialog(self, "Could not open file '%s'." % filename, 'Error', wx.OK | wx.ICON_ERROR)
			dlg.ShowModal()
			dlg.Destroy()
			return

		skiplines = self.sc.GetValue()
		selectdata = self.checkbox.GetValue()
		type = self.type.GetStringSelection()
		val1 = 0
		val2 = 0
		value1 = self.le2.GetValue()
		if value1: val1 = float(value1)
		value2 = self.le3.GetValue()
		if value2: val2 = float(value2)

		x, y, name = getImportFile(filename, skiplines, selectdata, type, val1, val2)

		self.xdata = x
		self.ydata = y
		self.dataname = name

		self.EndModal(wx.ID_OK)

##############################################################################
def getImportFile(filename, skiplines, selectdata, type, value1, value2):

	f = open(filename, 'r')
	for i in range(0, skiplines):
		f.readline()

	x = []
	y = []
	for line in f:
		a = line.split()
		if len(a) == 2:
			xp = a[0]
			yp = a[1]
		elif len(a) == 7:
			yp = a[6]
			xp = decimalDate(int(a[0]), int(a[1]), int(a[2]), int(a[3]), int(a[4]))
		elif len(a) == 6:
			yp = a[5]
			xp = decimalDate(int(a[0]), int(a[1]), int(a[2]), int(a[3]), int(a[4]))
		elif len(a) == 5:
			yp = a[4]
			xp = decimalDate(int(a[0]), int(a[1]), int(a[2]), int(a[3]), 0)
		elif len(a) == 4:
			yp = a[3]
			xp = decimalDate(int(a[0]), int(a[1]), int(a[2]), 12, 0)
		elif len(a) == 3:
			yp = a[2]
			xp = decimalDate(int(a[0]), int(a[1]), 15, 12, 0)

		yp = float(yp)
		xp = float(xp)
		if checkval(selectdata, type, yp, value1, value2):
			x.append(xp)
			y.append(yp)

	f.close()

	return x, y, os.path.basename(filename)

#scan $line "%*s %d %d %d %d %d %*s %*s %f %s" yr mo dy hr min yp flag

##############################################################################
def checkval(selectdata, stype, yp, val, val2):

	r = 0
	if selectdata:
		if stype == "less than":
			if yp < val: r = 1
		elif stype == "greater than":
			if yp > val: r = 1
		elif stype == "equal to":
			if yp == val: r = 1
		elif stype == "not equal to":
			if yp != val: r = 1
		elif stype == "less than or equal to":
			if yp <= val: r = 1
		elif stype == "greater than or equal to":
			if yp >= val: r = 1
		elif stype == "between":
			if yp >= val and yp <= val2: r = 1
		elif stype == "not between":
			if yp < val or yp > val2: r = 1
	else:
		r = 1

	if yp < -999.9:
		r = 0

	return r
